#!/usr/bin/perl

# Created by:
#   Stijn Van Looy <Stijn.VanLooy@rug.ac.be>
#
# Comments: Use at own risk, first doublecheck the files generated by this 
#   script, before you overwrite your licq configfiles. I guess you
#   ain't a fool. ;-)
#
# Tested with gnomeICU 0.93 and licq 0.81.

# HOW TO USE THIS SCRIPT:
#
# First you need to copy the gnomeICU config file (mostly found in
# ~/.gnome, depending on version, it can be named GnomeICU, gnomeicu,
# .GnomeICU, and so on) into the directory you put this script in,
# and rename it to GnomeICU.
#
# Then edit it so only the lines containing uin=alias remain in the file. 
# (The last line also needs a linefeed, otherwise the last char of the 
# last alias is stripped off)
#
# Run this script.
#
# Copy users.conf and the users dir into ~/.licq/

$infile = 'GnomeICU';
@uins = ();
@aliases = ();

open (infile, $infile);
while ($line = <infile>) {
	chop $line;
	$temp = $line;
	$temp =~ s/([0-9]+)=(.*)/\1/;
	push @uins, $temp;
	$line =~ s/([0-9]+)=(.*)/\2/;
	push @aliases, $line;
}
close infile;
$temp = $#uins + 1;
print "Converting $temp UINs ... \n";

$head = " 
[user]
History = default
Groups.System = 0
Groups.User = 1
Ip = 
Port = 
NewUser = 0
NewMessages = 0
LastOnline = 0
AutoAccept = 0
StatusToUser = 65535
CustomAutoRsp = \n";
$tail = "FirstName =
LastName =
Email1 =
Email2 =
City =
State =
PhoneNumber =
FaxNumber =
Address =
CellularNumber =
Zipcode = 0
Country = 65535
Timezone = 0
Authorization = 1
HideEmail = 0
Age = 65535
Gender = 0
Homepage =
BirthYear = 0
BirthMonth = 0
BirthDay = 0
Language1 = 0
Language2 = 0
Language3 = 0
CompanyCity =
CompanyState =
CompanyPhoneNumber =
CompanyFaxNumber =
CompanyAddress =
CompanyName =
CompanyDepartment =
CompanyPosition =
CompanyHomepage = \n";

system 'mkdir users; chmod 700 users';
for (0..$#uins) {
	$outfile = ">users/$uins[$_].uin";
	open (outfile, $outfile);
	print outfile $head;
	print outfile "Alias = $aliases[$_]\n";
	print outfile $tail;
	close outfile;
}

$outfile = '>users.conf';
open (outfile, $outfile);
$temp = $#uins + 1;
print outfile "[users]\nNumOfUsers = $temp\n";
for (0..$#uins) {
	$temp = $_ + 1;
	print outfile "User$temp = $uins[$_]\n";
}
close outfile;
print "Done.
Now copy the users dir and the users.conf file into your licq dir (~/.licq).\n"